//
// SearchAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class SearchAPI {
    /**
     Search face recognition events

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchFaces(body: SearchFaceBody, completion: @escaping ((_ data: SearchFaceResultList?,_ error: Error?) -> Void)) {
        searchFacesWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search face recognition events
     - POST /api/v1/search/face
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "events" : [ {
    "streamserver_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_action" : "event_action",
    "event_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_type" : "event_type",
    "stream_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "similarity" : 0.19242678333663643,
    "event_data" : {
      "detection" : {
        "bbox" : [ 6.027456183070403, 6.027456183070403 ]
      },
      "attributes" : { },
      "descriptor" : {
        "data" : "data",
        "norm" : 1.4658129805029452
      }
    },
    "object_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "ts" : 0
  }, {
    "streamserver_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_action" : "event_action",
    "event_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_type" : "event_type",
    "stream_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "similarity" : 0.19242678333663643,
    "event_data" : {
      "detection" : {
        "bbox" : [ 6.027456183070403, 6.027456183070403 ]
      },
      "attributes" : { },
      "descriptor" : {
        "data" : "data",
        "norm" : 1.4658129805029452
      }
    },
    "object_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "ts" : 0
  } ]
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<SearchFaceResultList> 
     */
    open class func searchFacesWithRequestBuilder(body: SearchFaceBody) -> RequestBuilder<SearchFaceResultList> {
        let path = "/api/v1/search/face"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<SearchFaceResultList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
    /**
     Search plate recognition events

     - parameter body: (body)  
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func searchPlates(body: SearchPlateBody, completion: @escaping ((_ data: SearchPlateResultList?,_ error: Error?) -> Void)) {
        searchPlatesWithRequestBuilder(body: body).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     Search plate recognition events
     - POST /api/v1/search/plate
     - 

     - OAuth:
       - type: oauth2
       - name: OAuth2PasswordBearer
     - examples: [{contentType=application/json, example={
  "events" : [ {
    "streamserver_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_action" : "event_action",
    "event_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_type" : "event_type",
    "stream_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "similarity" : 0.20549123661408064,
    "event_data" : {
      "detection" : {
        "bbox" : [ 6.027456183070403, 6.027456183070403 ]
      },
      "plate_number" : {
        "data" : "data"
      }
    },
    "object_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "ts" : 0
  }, {
    "streamserver_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_action" : "event_action",
    "event_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "event_type" : "event_type",
    "stream_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "similarity" : 0.20549123661408064,
    "event_data" : {
      "detection" : {
        "bbox" : [ 6.027456183070403, 6.027456183070403 ]
      },
      "plate_number" : {
        "data" : "data"
      }
    },
    "object_id" : "046b6c7f-0b8a-43b9-b35d-6489e6daee91",
    "ts" : 0
  } ]
}}]
     - parameter body: (body)  

     - returns: RequestBuilder<SearchPlateResultList> 
     */
    open class func searchPlatesWithRequestBuilder(body: SearchPlateBody) -> RequestBuilder<SearchPlateResultList> {
        let path = "/api/v1/search/plate"
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<SearchPlateResultList>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "POST", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
